--- a/cpswhal_cpsar.h
+++ b/cpswhal_cpsar.h
@@ -430,10 +430,10 @@ typedef struct
   int   (*DeviceFindInfo)(int Inst, const char *DeviceName, void *DeviceInfo);
   int   (*DeviceFindParmUint)(void *DeviceInfo, const char *Parm, bit32u *Value);
   int   (*DeviceFindParmValue)(void *DeviceInfo, const char *Parm, void *Value);
-  void  (*Free)(void *MemPtr);
+  void  (*Free)(const void *MemPtr);
   void  (*FreeRxBuffer)(OS_RECEIVEINFO *OsReceiveInfo, void *MemPtr);
-  void  (*FreeDev)(void *MemPtr);
-  void  (*FreeDmaXfer)(void *MemPtr);
+  void  (*FreeDev)(const void *MemPtr);
+  void  (*FreeDmaXfer)(const void *MemPtr);
   void  (*IsrRegister)(OS_DEVICE *OsDev, int (*halISR)(HAL_DEVICE*, int*), int InterruptBit);
   void  (*IsrUnRegister)(OS_DEVICE *OsDev, int InterruptBit);
   void* (*Malloc)(bit32u size);
--- a/cpswhal_cpaal5.h
+++ b/cpswhal_cpaal5.h
@@ -430,10 +430,10 @@ typedef struct
   int   (*DeviceFindInfo)(int Inst, const char *DeviceName, void *DeviceInfo);
   int   (*DeviceFindParmUint)(void *DeviceInfo, const char *Parm, bit32u *Value);
   int   (*DeviceFindParmValue)(void *DeviceInfo, const char *Parm, void *Value);
-  void  (*Free)(void *MemPtr);
+  void  (*Free)(const void *MemPtr);
   void  (*FreeRxBuffer)(OS_RECEIVEINFO *OsReceiveInfo, void *MemPtr);
-  void  (*FreeDev)(void *MemPtr);
-  void  (*FreeDmaXfer)(void *MemPtr);
+  void  (*FreeDev)(const void *MemPtr);
+  void  (*FreeDmaXfer)(const void *MemPtr);
   void  (*IsrRegister)(OS_DEVICE *OsDev, int (*halISR)(HAL_DEVICE*, int*), int InterruptBit);
   void  (*IsrUnRegister)(OS_DEVICE *OsDev, int InterruptBit);
   void* (*Malloc)(bit32u size);
--- a/tn7atm.c
+++ b/tn7atm.c
@@ -2481,7 +2481,7 @@ static int tn7atm_proc_qos_read(struct s
     return 0;
 
 }
-static int tn7atm_proc_qos_write(struct file *fp, const char *buf, unsigned long count, void *data)
+static int tn7atm_proc_qos_write(struct file *fp, const char *buf, size_t count, loff_t *data)
 {
     char local_buf[32];
 
--- a/tn7dsl.c
+++ b/tn7dsl.c
@@ -1712,7 +1712,7 @@ static int tn7dsl_proc_stats_open(struct
 	return single_open(file, tn7dsl_proc_stats, PDE_DATA(inode));
 }
 
-int tn7dsl_proc_write_stats (struct file *fp, const char *buf, unsigned long count, void *data);
+int tn7dsl_proc_write_stats (struct file *fp, const char *buf, size_t count, loff_t *data);
 
 struct file_operations tn7dsl_proc_stats_fops = {
 	.owner 		= THIS_MODULE,
@@ -4256,7 +4256,7 @@ int tn7dsl_generic_write( int offsetnum,
 }
 
 int tn7dsl_proc_write_stats (struct file *fp, const char *buf,
-                             unsigned long count, void *data)
+                             size_t count, loff_t *data)
 {
     char local_buf[31];
     int  ret_val = 0;
